package jp.ac.kyutech.mns.ist;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.geom.Point2D;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;

import edu.umd.cs.piccolo.PCanvas;
import edu.umd.cs.piccolo.event.PInputEvent;

public class PopupMenu_forSheet extends JPopupMenu {
	private static final long serialVersionUID = 7741402910818721975L;

	Sheet sheet;
	PInputEvent ie;
	PCanvas canvas;

	public PopupMenu_forSheet(Sheet aSheet, PInputEvent _ie, PCanvas _canvas /*, JFrame _frame*/) {
		sheet = aSheet;
		ie = _ie;
		canvas = _canvas;

		setLightWeightPopupEnabled(false);

		JMenuItem menuItem;

		menuItem = new JMenuItem("cancel");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0));//メニュー表示時のショートカットキー

		addSeparator();

		menuItem = new JMenuItem("Zoom Out");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, 0));//メニュー表示時のショートカットキー
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//ここに，機能１の処理をかく．必要に応じて，sheet参照やクリック時イベント参照(ie)をつかう．
				SimpleATN.theapp.upview();
			}
		});

		menuItem = new JMenuItem("Zoom Home");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, 0));//メニュー表示時のショートカットキー
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//ここに，機能２の処理をかく．必要に応じて，sheet参照やクリック時イベント参照(ie)をつかう．
				SimpleATN.theapp.zoomToBounds(SimpleATN.theapp.tempAfterLayoutBounds, 1000,"PopupMenu_forSheet");
			}
		});
		
		addSeparator();
		
		menuItem = new JMenuItem("シート["+sheet.num+"]を必ず表示");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2, 0));//メニュー表示時のショートカットキー
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SimpleATN.theapp.setSheetVisible(sheet.num, 2);
			}
		});
		menuItem = new JMenuItem("筆記があれば表示");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, 0));//メニュー表示時のショートカットキー
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SimpleATN.theapp.setSheetVisible(sheet.num, 1);
			}
		});
		menuItem = new JMenuItem("このシートを非表示");
		add(menuItem);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_0, 0));//メニュー表示時のショートカットキー
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SimpleATN.theapp.setSheetVisible(sheet.num, 0);
			}
		});
		
		//追加のメニューは，プラグインが直接オンデマンドで追加する
		sheet.addPluginMenuTo(this);

		showPopup();
	}

	public void showPopup() {
		Point2D cp = ie.getPositionRelativeTo(canvas.getCamera());

		show(canvas, (int)cp.getX(), (int)cp.getY());
	}
}
